# -*- coding: utf-8 -*-
"""
contains pwe specfic validators
"""
import collections
import formbar.form as formbar_form
from ringo.views.helpers import get_item_from_request

Validator = collections.namedtuple("Validator", "function message triggers")

validator_fns = []
validator_fns2 = []
_ = lambda x: x

# Action modes
CREATE = 0
UPDATE = 1

# Projects in support phase/förderpahse/fp
FP1 = 1
FP2 = 2

# Key values used in forms
JA = 1
NEIN = 0
QUALIFIZIERT = 0
MINIJOB = 2
PFLEGE = 1
HDL = 3
TRIFFT_NICHT_ZU_KINDER = 5
TRIFFT_NICHT_ZU_PFLEGE = 4
WENIGER_ALS_EIN_JAHR = 1
KEINE_PAUSE = 5
ZG_A = 1
ZG_B = 2
ZG_C1 = 3
ZG_C2 = 4
ZG_C3 = 5
ZG_C4 = 6

# Placeholders, namespace reflecting keys will be set by _set_namespace()
PROJECT = ""
ZIELGRUPPE = ""
ZIELGRUPPE_FP2 = ""
PAUSE_WEGEN_KINDER = ""
PAUSE_WEGEN_PFLEGE = ""
FAMILIENPHASE = ""
ERWERBSTAETIG = ""
ERWERBSPAUSE = ""
IN_ALLGEMEINBILDENDER_SCHULE = ""
AUSZUBILDENDER = ""
IN_SCHULISCHER_AUSBILDUNG = ""
VOLLZEIT_STUDENT = ""
LANGZEITARBEITSLOS = ""
ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE = ""
ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE = ""
SELBSTAENDIG = ""
GERINGFUEGIGE_SELBSTAENDIGKEIT = ""
MINIJOB_WEGEN_PFLEGE = ""
MINIJOB = ""
IN_TRAINING = ""

NOT_ELIGIBLE = _("The participant is not eligible, beacause: ")

KEINE_LANGZEITARBEITSLOSEN = _("Longterm unemployed selected (32.1) was selected")
KINDER_UND_PFLEGE_TRIFFT_NICHT_ZU = _("Neither children nor care does apply (8.1, 31.1, 31.2)")
KEINE_FAMILIENPHASE = _("No familyphase (8.1, 8.2) was selected")
KEINE_ERWERBSTAETIGEN = _("No employed people (16.1) was selected")
KEINE_ERWERBSPAUSE = _("No pause  was selected (8.1, 30)")
KURZE_ERWERBSPAUSE_OHNE_PFLEGE = _("Pause less than a year was selected without care (8.1, 30, 31.2)")
KEINE_NOCH_IN_BILDUNG = _("Is still in Education (8.1, 16.4, 16.5, 16.6, 16.7)")
KEINE_PFLEGE_OHNE_BERUFSERFAHRUNG = _("No adequate jobexperience with care (8.1, 18.2)")
KEIN_MINIJOB_WEGEN_PFLEGE = _("No minijob due to care (8.1, 16.2.1)")
KEINE_QUALIFIZIERTEN_OHNE_BERUFSERFAHRUNG = _("No adequate jobexperience as qualified (8.1, 18.1)")
KEINE_GERINGE_SELBSTAENDIGKEIT = _("No minijoblike selfemployment (8.1, 16.3.1)")
KEINE_PFLEGE_OHNE_FAMILIENPHASE_WEGEN_KINDER = _("Care and no children familyphase (8.1, 8.2)")
PFLEGE_KEINE_ERWERBSPAUSE_WEGEN_PFLEGE = _("No pause due to care but qualified as care (8.1, 31.2)")

KEINE_FAMILIENPHASE_FP2 = _("No familyphase (8.2) was selected")
KINDER_UND_PFLEGE_TRIFFT_NICHT_ZU_FP2 = _("Neither children nor care does apply (31.1, 31.2)")
KEINE_LANGZEITARBEITSLOSEN_FP2 = _("Longterm unemployed selected (8.1, 32.1) was selected")
KEINE_ERWERBSTAETIGEN_FP2 =  _("No employed people (8.1, 16.1) was selected")
KEINE_MINIJOB_FP2 = _("No minijob due to care (8.1, 16.2.1)")
KEINE_BERUFSAUSBILDUNG_FP2 = u"Es liegt keine abgeschlossene Berufsausbildung/kein abgeschlossenes Studium vor."

KEINE_GERINGFUEGE_SELBSTSTAENIGKEIT_FP2 = _("No minor job and self-employed (8.1, 16.3.1) was selected")
KEINE_X_BEI_HDL_ZUSCHUSS_FP2 = _("Not right targetgroup for house service (8.1, 16.")

def _set_namespace(action):
    """Overwrite the global name placeholder in case of a CREATE action."""

    global PROJECT
    global ZIELGRUPPE
    global ZIELGRUPPE_FP2
    global PAUSE_WEGEN_KINDER
    global PAUSE_WEGEN_PFLEGE
    global FAMILIENPHASE
    global ERWERBSTAETIG
    global ERWERBSPAUSE
    global IN_ALLGEMEINBILDENDER_SCHULE
    global AUSZUBILDENDER
    global IN_SCHULISCHER_AUSBILDUNG
    global VOLLZEIT_STUDENT
    global LANGZEITARBEITSLOS
    global ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE
    global ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE
    global SELBSTAENDIG
    global GERINGFUEGIGE_SELBSTAENDIGKEIT
    global MINIJOB_WEGEN_PFLEGE
    global MINIJOB
    global IN_TRAINING

    if action == CREATE:
        PROJECT = "_project"
        ZIELGRUPPE = "_pwe_targetgroup"
        ZIELGRUPPE_FP2 = "_pwe_targetgroup_fp2"
        PAUSE_WEGEN_KINDER = "_pwe_acquisition_pause_reason"
        PAUSE_WEGEN_PFLEGE = "_pwe_acquisition_pause_reason_care"
        FAMILIENPHASE = "_pwe_targetgroup_family_phase"
        ERWERBSTAETIG = "_lm_employment_category_employed"
        ERWERBSPAUSE = "_pwe_acquisition_pause"
        IN_ALLGEMEINBILDENDER_SCHULE = "_lm_employment_category_school"
        AUSZUBILDENDER = "_lm_employment_category_education_enterprise"
        IN_SCHULISCHER_AUSBILDUNG = "_lm_employment_category_education_school"
        VOLLZEIT_STUDENT = "_lm_employment_category_fulltime_student"
        LANGZEITARBEITSLOS = "_pwe_labour_interruption"
        ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE = "_edu_attainment_vocational_experience2"
        ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE = "_edu_attainment_vocational_experience"
        SELBSTAENDIG = "_lm_employment_category_selfemployed"
        GERINGFUEGIGE_SELBSTAENDIGKEIT = "_lm_employment_category_selfemployed_reduced"
        MINIJOB_WEGEN_PFLEGE = "_lm_employment_category_underemployed_reduced"
        MINIJOB = "_lm_employment_category_underemployed"
        IN_TRAINING = "_lm_employment_category_training"
    else:
        PROJECT = "project"
        ZIELGRUPPE = "pweoi.pwe_targetgroup"
        ZIELGRUPPE_FP2 = "pweoi.pwe_targetgroup_fp2"
        PAUSE_WEGEN_KINDER = "pweoi.pwe_acquisition_pause_reason"
        PAUSE_WEGEN_PFLEGE = "pweoi.pwe_acquisition_pause_reason_care"
        FAMILIENPHASE = "pweoi.pwe_targetgroup_family_phase"
        ERWERBSTAETIG = "pweoi.lm_employment_category_employed"
        ERWERBSPAUSE = "pweoi.pwe_acquisition_pause"
        IN_ALLGEMEINBILDENDER_SCHULE = "pweoi.lm_employment_category_school"
        AUSZUBILDENDER = "pweoi.lm_employment_category_education_enterprise"
        IN_SCHULISCHER_AUSBILDUNG = "pweoi.lm_employment_category_education_school"
        VOLLZEIT_STUDENT = "pweoi.lm_employment_category_fulltime_student"
        LANGZEITARBEITSLOS = "pweoi.pwe_labour_interruption"
        ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE = "pweoi.edu_attainment_vocational_experience2"
        ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE = "pweoi.edu_attainment_vocational_experience"
        SELBSTAENDIG = "pweoi.lm_employment_category_selfemployed"
        GERINGFUEGIGE_SELBSTAENDIGKEIT = "pweoi.lm_employment_category_selfemployed_reduced"
        MINIJOB_WEGEN_PFLEGE = "pweoi.lm_employment_category_underemployed_reduced"
        MINIJOB = "pweoi.lm_employment_category_underemployed"
        IN_TRAINING = "pweoi.lm_employment_category_training"


def Validate(error_message="", triggers="warning", fp2=False):
    def outer(fun):
        def generate_validation_function(fn):
            def eligibility_validator(field, data, request):
                try:
                    formdata = Entries(data)
                    fn(formdata)
                except AssertionError:
                    return False
                else:
                    return True
            return eligibility_validator
        f = generate_validation_function(fun)
        if fp2:
            validator_fns2.append(Validator(f, error_message, triggers))
        else:
            validator_fns.append(Validator(f, error_message, triggers))

        def inner(field, data, request):
            return f(field, data, request)
        return inner
    return outer

class Entries(object):

    def __init__(self, data):
        self.data = data

    def is_selected(self, option, value):
        return self.data.get(option) == value

    def check_option(self, option, check_function=None):
        if not check_function:
            check_function = lambda x: True
        return check_function(self.data.get(option))

def qualifiziert_oder_minijob_oder_hdl(form):
    return (form.is_selected(ZIELGRUPPE, QUALIFIZIERT) or
            form.is_selected(ZIELGRUPPE, MINIJOB) or
            form.is_selected(ZIELGRUPPE, HDL))

def qualifiziert_oder_pflege_oder_minijob(form):
    return (form.is_selected(ZIELGRUPPE, QUALIFIZIERT) or
            form.is_selected(ZIELGRUPPE, PFLEGE) or
            form.is_selected(ZIELGRUPPE, MINIJOB))


@Validate(error_message=KEINE_LANGZEITARBEITSLOSEN, triggers="error")
def long_term_unemployed(selected):
    if qualifiziert_oder_pflege_oder_minijob(selected):
        assert(not selected.is_selected(LANGZEITARBEITSLOS, JA))

@Validate(error_message=KINDER_UND_PFLEGE_TRIFFT_NICHT_ZU, triggers="error")
def check_targetgroup_children_care(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        pausenzeiten = (form.is_selected(PAUSE_WEGEN_KINDER, TRIFFT_NICHT_ZU_KINDER) and
                        form.is_selected(PAUSE_WEGEN_PFLEGE, TRIFFT_NICHT_ZU_PFLEGE))
        assert(not pausenzeiten)

@Validate(error_message=KEINE_FAMILIENPHASE, triggers="error")
def check_targetgroup_familyphase(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        assert(not form.is_selected(FAMILIENPHASE, NEIN))

@Validate(error_message=KEINE_ERWERBSTAETIGEN, triggers="error")
def check_targetgroup_working(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        assert(not form.is_selected(ERWERBSTAETIG, JA))

@Validate(error_message=KEINE_ERWERBSPAUSE, triggers="error")
def check_targetgroup_pause(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        assert(not form.is_selected(ERWERBSPAUSE, KEINE_PAUSE))

@Validate(error_message=KURZE_ERWERBSPAUSE_OHNE_PFLEGE, triggers="error")
def check_targetgroup_pause_without_care(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        pausen = (form.is_selected(ERWERBSPAUSE, WENIGER_ALS_EIN_JAHR) and
                  form.is_selected(PAUSE_WEGEN_PFLEGE, TRIFFT_NICHT_ZU_PFLEGE))
        assert(not pausen)

@Validate(error_message=KEINE_NOCH_IN_BILDUNG, triggers="error")
def check_targetgroup_education(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        assert(not form.is_selected(IN_ALLGEMEINBILDENDER_SCHULE, JA))
        assert(not form.is_selected(AUSZUBILDENDER, JA))
        assert(not form.is_selected(IN_SCHULISCHER_AUSBILDUNG, JA))
        assert(not form.is_selected(VOLLZEIT_STUDENT, JA))

@Validate(error_message=KEINE_PFLEGE_OHNE_BERUFSERFAHRUNG, triggers="error")
def no_finished_education(form):
    if form.is_selected(ZIELGRUPPE, PFLEGE):
        assert(not form.is_selected(ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE, NEIN))

@Validate(error_message=KEINE_PFLEGE_OHNE_FAMILIENPHASE_WEGEN_KINDER, triggers="error")
def no_finished_education_children(form):
    if form.is_selected(ZIELGRUPPE, PFLEGE):
        assert(not form.is_selected(FAMILIENPHASE, NEIN))

@Validate(error_message=PFLEGE_KEINE_ERWERBSPAUSE_WEGEN_PFLEGE, triggers="error")
def no_finished_education_care(form):
    if form.is_selected(ZIELGRUPPE, PFLEGE):
        assert(not form.is_selected(PAUSE_WEGEN_PFLEGE, TRIFFT_NICHT_ZU_PFLEGE))

@Validate(error_message=KEIN_MINIJOB_WEGEN_PFLEGE, triggers="error")
def no_minijob(form):
    if form.is_selected(ZIELGRUPPE, PFLEGE):
        assert(not form.is_selected(MINIJOB_WEGEN_PFLEGE, NEIN))

@Validate(error_message=KEINE_QUALIFIZIERTEN_OHNE_BERUFSERFAHRUNG, triggers="error")
def no_qualified(form):
    if form.is_selected(ZIELGRUPPE, QUALIFIZIERT):
        assert(not form.is_selected(ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE, NEIN))

@Validate(error_message=KEINE_GERINGE_SELBSTAENDIGKEIT, triggers="error")
def check_targetgroup_level3(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        geringe_selbstaendigkeit = (form.is_selected(SELBSTAENDIG, JA) and
                                    form.is_selected(GERINGFUEGIGE_SELBSTAENDIGKEIT, NEIN))
        assert(not geringe_selbstaendigkeit)

# FP2 Validators
# LEVEL 1
@Validate(fp2=True, error_message=KEINE_FAMILIENPHASE_FP2, triggers="error")
def check_targetgroup_familyphase_fp2(form):
    assert(not form.is_selected(FAMILIENPHASE, NEIN))


@Validate(fp2=True, error_message=KINDER_UND_PFLEGE_TRIFFT_NICHT_ZU_FP2,
          triggers="error")
def check_targetgroup_children_care_fp2(form):
    pausenzeiten = (form.is_selected(PAUSE_WEGEN_KINDER,
                                     TRIFFT_NICHT_ZU_KINDER) and
                    form.is_selected(PAUSE_WEGEN_PFLEGE,
                                     TRIFFT_NICHT_ZU_PFLEGE))
    assert(not pausenzeiten)

# LEVEL 2
@Validate(fp2=True, error_message=KEINE_LANGZEITARBEITSLOSEN_FP2,
          triggers="error")
def long_term_unemployed_fp2(selected):
    if selected.is_selected(ZIELGRUPPE_FP2, ZG_A):
        assert(not selected.is_selected(LANGZEITARBEITSLOS, JA))


def targetgroup_in_a_b_c3(form):
    targetgroup_a = form.is_selected(ZIELGRUPPE_FP2, ZG_A)
    targetgroup_b = form.is_selected(ZIELGRUPPE_FP2, ZG_B)
    targetgroup_c3 = form.is_selected(ZIELGRUPPE_FP2, ZG_C3)
    return targetgroup_a or targetgroup_b or targetgroup_c3


@Validate(fp2=True, error_message=KEINE_ERWERBSTAETIGEN_FP2, triggers="error")
def check_targetgroup_working_fp2(form):
    if targetgroup_in_a_b_c3(form):
        assert(not form.is_selected(ERWERBSTAETIG, JA))
        assert(not form.is_selected(SELBSTAENDIG, JA))


@Validate(fp2=True, error_message=KEINE_MINIJOB_FP2, triggers="error")
def check_entry_no_minijob(form):
    if form.is_selected(ZIELGRUPPE_FP2, ZG_C3):
        assert(not form.is_selected(MINIJOB_WEGEN_PFLEGE, NEIN))


def targetgroup_in_a_b_c2_c3(form):
    targetgroup_a = form.is_selected(ZIELGRUPPE_FP2, ZG_A)
    targetgroup_b = form.is_selected(ZIELGRUPPE_FP2, ZG_B)
    targetgroup_c2 = form.is_selected(ZIELGRUPPE_FP2, ZG_C2)
    targetgroup_c3 = form.is_selected(ZIELGRUPPE_FP2, ZG_C3)
    return targetgroup_a or targetgroup_b or targetgroup_c2 or targetgroup_c3


@Validate(fp2=True, error_message=KEINE_ERWERBSPAUSE, triggers="error")
def check_targetgroup_pause_fp2(form):
    if targetgroup_in_a_b_c2_c3(form):
        assert(not form.is_selected(ERWERBSPAUSE, KEINE_PAUSE))


@Validate(fp2=True, error_message=KURZE_ERWERBSPAUSE_OHNE_PFLEGE,
          triggers="error")
def check_targetgroup_pause_without_care_fp2(form):
    if targetgroup_in_a_b_c2_c3(form):
        pausen = (form.is_selected(ERWERBSPAUSE, WENIGER_ALS_EIN_JAHR) and
                  form.is_selected(PAUSE_WEGEN_PFLEGE, TRIFFT_NICHT_ZU_PFLEGE))
        assert(not pausen)

@Validate(fp2=True, error_message=PFLEGE_KEINE_ERWERBSPAUSE_WEGEN_PFLEGE,
          triggers="error")
def no_break_care_fp2(form):
    if form.is_selected(ZIELGRUPPE_FP2, ZG_C1):
        assert(not form.is_selected(PAUSE_WEGEN_PFLEGE,
                                    TRIFFT_NICHT_ZU_PFLEGE))


@Validate(fp2=True, error_message=KEINE_BERUFSAUSBILDUNG_FP2,
          triggers="error")
def no_finished_education_fp2(form):
    targetgroup_a = form.is_selected(ZIELGRUPPE_FP2, ZG_A)
    targetgroup_c2 = form.is_selected(ZIELGRUPPE_FP2, ZG_C2)
    if targetgroup_a or targetgroup_c2:
        assert(not form.is_selected(
            ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE, NEIN))


@Validate(fp2=True, error_message=KEIN_MINIJOB_WEGEN_PFLEGE, triggers="error")
def no_minijob_of_care_fp2(form):
    if form.is_selected(ZIELGRUPPE_FP2, ZG_C1):
        assert(not form.is_selected(MINIJOB_WEGEN_PFLEGE, NEIN))


@Validate(fp2=True, error_message=KEINE_GERINGFUEGE_SELBSTSTAENIGKEIT_FP2,
          triggers="error")
def check_targetgroup_level3_fp2(form):
    targetgroup_a = form.is_selected(ZIELGRUPPE_FP2, ZG_A)
    targetgroup_b = form.is_selected(ZIELGRUPPE_FP2, ZG_B)
    if targetgroup_a or targetgroup_b:
        geringe_selbstaendigkeit = (form.is_selected(SELBSTAENDIG, JA) and
                                    form.is_selected(
                                        GERINGFUEGIGE_SELBSTAENDIGKEIT, NEIN))
        assert(not geringe_selbstaendigkeit)


@Validate(fp2=True, error_message=KEINE_X_BEI_HDL_ZUSCHUSS_FP2,
          triggers="error")
def check_job_quali_minijob_by_hdl(form):
    if form.is_selected(ZIELGRUPPE_FP2, ZG_C4):
        not_erwerbstaetig = form.is_selected(ERWERBSTAETIG, NEIN)
        not_selbstaendig = form.is_selected(SELBSTAENDIG, NEIN)
        not_in_school = form.is_selected(IN_SCHULISCHER_AUSBILDUNG, NEIN)
        not_in_training = form.is_selected(IN_TRAINING, NEIN)
        minijob = form.is_selected(MINIJOB, JA)
        check = (not_erwerbstaetig or not_selbstaendig or not_in_school or
                 not_in_training or minijob)
        assert(not check)


def get_eligibility_validators(request):
    cal_validator_fns = validator_fns
    if request.matched_route and request.matched_route.name and \
       (request.matched_route.name == u'participations-create' or
        request.matched_route.name == u'participants-create'):
            _set_namespace(CREATE)
            if request.params.get('_project') == str(FP2):
                cal_validator_fns = validator_fns2
    else:
        if get_item_from_request(request).project_id == FP2:
            cal_validator_fns = validator_fns2
        _set_namespace(UPDATE)
    return [generate_validator(request, v.message, v.function, v.triggers)
            for v in cal_validator_fns]

def generate_validator(request, message, fn, t):
    _ = request.translate
    msg = _(NOT_ELIGIBLE) + _(message)
    return formbar_form.Validator(None, msg, fn, request, triggers=t)
